﻿CREATE OR REPLACE PACKAGE BODY API_UTILISATEUR IS

FUNCTION CREERUTILISATEUR(
			 PERSID NUMBER,
			 DATEDEBUT DATE,
			 DATEFIN DATE			 
	  )
   RETURN NUMBER
	IS
	  CPT NUMBER;
	  NOIND NUMBER;	  
	  UTLORDRE NUMBER;
   BEGIN
   		IF (PERSID IS NULL ) THEN
		 		  RAISE_APPLICATION_ERROR (-20001,'Parametre persId est null ');
		END IF;
   
   		SELECT COUNT(*) INTO CPT FROM V_INDIVIDU_ULR WHERE PERS_ID=PERSID;
   		IF (CPT = 0) THEN
		 	RAISE_APPLICATION_ERROR (-20001,'INDIVIDU correspondant a pers_id=' || PERSID ||' introuvable');
		 END IF;
   
   
   		SELECT COUNT(*) INTO CPT FROM V_INDIVIDU_ULR WHERE PERS_ID=PERSID AND TEM_VALIDE<>'O';
   		IF (CPT > 0) THEN
		 	RAISE_APPLICATION_ERROR (-20001,'INDIVIDU correspondant a pers_id=' || PERSID ||'  existe mais n''est pas valide');
		END IF;     
   
   
      	IF (DATEDEBUT IS NULL ) THEN
		 		  RAISE_APPLICATION_ERROR (-20001,'Parametre dateDebut est null ');
		END IF;
   
      	IF (DATEFIN IS NOT NULL ) THEN
		 		 IF (DATEFIN < DATEDEBUT) THEN
		 		  		RAISE_APPLICATION_ERROR (-20001,'DateDebut > dateFin ');
				 END IF;
		END IF;
   
   
      	SELECT NO_INDIVIDU INTO NOIND FROM V_INDIVIDU_ULR WHERE PERS_ID=PERSID AND TEM_VALIDE='O';
   		SELECT COUNT(*) INTO CPT FROM UTILISATEUR WHERE PERS_ID = PERSID;
   		IF (CPT>0) THEN
		   	  -- l'utilisateur existe deja
			  SELECT UTL_ORDRE  INTO UTLORDRE FROM UTILISATEUR WHERE PERS_ID = PERSID;
			 -- on met a jour les infos (date + validite)
			 UPDATE UTILISATEUR SET UTL_OUVERTURE=DATEDEBUT, UTL_FERMETURE=DATEFIN, TYET_ID=1 WHERE UTL_ORDRE=UTLORDRE;
	 
		ELSE
			 SELECT UTILISATEUR_SEQ.NEXTVAL INTO UTLORDRE FROM DUAL;		 
			 INSERT INTO JEFY_ADMIN.UTILISATEUR (
	   		 			 UTL_ORDRE, NO_INDIVIDU, PERS_ID, 
	   					UTL_OUVERTURE, UTL_FERMETURE, TYET_ID) 
						VALUES (
	   		 			UTLORDRE, 
						 NOIND, 
						 PERSID, 
	   					 DATEDEBUT, 
						 DATEFIN, 
						 1) ;		 
   		END IF;
   
   		RETURN UTLORDRE;
	END;

END;
/
